// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe,Mathematik)
#include <cstdlib>
#include <stdio.h>
#include <math.h>
#include "hilf.h"
#include <iostream>
using namespace std;

void zufall(int n,float *x) 
 // n zufallszahlen auf (0,1)
// Parameter seed.. Zeit in sec seit 1.1.1970 (im 1. Schritt)
//     fuer zufaellige Initialisierung der Zufallszahlen    
//     Typ ist static int, d.h. bei erneutem Aufruf 
//     wird diese Variable auf den alten Wert gesetzt.
{
  unsigned long int m,z1,z,k;
  static long int seed=time(0);
  static long int z0=1;
  z1=seed;
  m=2*(32768*32768-1)+1;
  for (k=1;k<n+1;k++)
    {
      z=(1999*z1+4444*z0)%m; // Generation gemaess Vorlesung
      z0=z1;
      z1=z;  
      x[k-1]=float(z)/float(m); // Transformation auf [0,1)
    }
   seed=z1;
}

void Farben(long int* cData)
// Farben fuer die Balken in Gnuplot in rgb
{
  cData[0]=65536*128+256*128+128;
  cData[1]=65536*128+256*0  +128;
  cData[5]=65536*  0+256*  0+  0;
  cData[6]=65536*  0+256*128+255;  
  cData[11]=65536*255+256*  0+255; 
  cData[12]=65536*  0+256*128+128; 
  cData[16]=65536*255+256*128+  0; 
  cData[21]=65536*255+256*  0+  0; 
  cData[26]=65536*230+256*200+  0; 
  cData[31]=65536*  0+256*200+  0; 
  cData[37]=65536*  0+256*  0+255; 
  cData[2]=cData[0]; 
  cData[3]=cData[1]; 
  cData[4]=cData[0]; 
  cData[7]=cData[0]; 
  cData[8]=cData[6]; 
  cData[9]=cData[6]; 
  cData[10]=cData[0]; 
  cData[13]=cData[11];
  cData[14]=cData[11]; 
  cData[15]=cData[5]; 
  cData[17]=cData[0]; 
  cData[18]=cData[16]; 
  cData[19]=cData[16]; 
  cData[20]=cData[0]; 
  cData[22]=cData[2]; 
  cData[23]=cData[21];
  cData[24]=cData[21]; 
  cData[25]=cData[5]; 
  cData[27]=cData[26]; 
  cData[28]=cData[12]; 
  cData[29]=cData[26]; 
  cData[30]=cData[0]; 
  cData[32]=cData[31]; 
  cData[33]=cData[0];
  cData[34]=cData[31]; 
  cData[35]=cData[5]; 
  cData[36]=cData[0]; 
  cData[38]=cData[0];
  cData[39]=cData[37];
}


void PlotBalken(long int* zData, int dataSize,long int* cData) 
{  
  const char * commandsForGnuplot[] = {"set title \"Werte\" ",
                                 "set xtics ('L' 0,'B' 1,'G' 2,'T' 3,'S' 4,'S' 5,'C' 6,'E' 7,'E' 8,'P' 9,'G' 10,'S' 11,'E' 12,'H' 13,'N' 14,'W' 15,'M' 16,'G' 17,'W' 18,'B' 19,'F' 20,'T' 21,'E' 22,'M' 23,'O' 24,'N' 25,'L' 26,'S' 27,'W' 28,'G' 29,'G' 30,'R' 31,'H' 32,'G' 33,'B' 34,'H' 35,'E' 36,'P' 37,'S' 38,'S' 39)",
      "set style fill solid 1.0",
      "plot 'data.temp' using 1:2:3:($4) with boxes lw 9 lc rgb variable",
      "replot"
                                 };
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
    int i;
    for (i=0; i < dataSize; i++)
    {
      fprintf(temp, "%i %li %i %li\n", i,zData[i],0,cData[i]); 
    }
    for (i=0; i < 8; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[i]); 
    }
    
}

void Monopoly_Zufall(int *n1,int *n2, int *n3)
// zieht 3 Zufallszahlen
// n1,n2 Zahlen fuer den Wuerfel 1..6 gleichverteilt
// n3 Karte fuer Ereignis/Gemeinsschaftsfeld, 
// d.h. 1..16 gleichverteilt
{
  const int N=3;
  float x[N];  
  zufall(3,x); // Ziehen von 3 Zufallszahlen
  *n1=1+int(floor(6)*x[0]);
  *n2=1+int(floor(6)*x[1]);
  *n3=1+int(floor(16)*x[2]);
}

void monopoly(long int *x,int m)
// x.. Zufallsgroesse der felder
// m anzahl ziehungen
// k.. aktuelles feld im Spielplan 0..39 (Los-Schlossallee)
// r .. Parameter fuer Pasch
{ int l,n1,n2,n3;
  int r,k;
  k=0;
  r=0;
  l=0;
  while (l<m)
    { 
      // Wuerfeln und evtl. Karte ziehen
      Monopoly_Zufall(&n1,&n2,&n3);
      l=l+1;
      if (n1==n2) 
        {
         r=r+1;
        }
      else
        {
	  r=0;
        }
      // 3 mal Pasch-> Gefaengnis
      if (r==3) 
        {
        k=10;
        }
      else
        {  
	  k=(k+n1+n2)%40;
        }
      // Ereignisfeld
      if ((k==7)||(k==22)||(k==36))
           { 
	     if (n3==1) k=0;  // auf Los
             if (n3==2) k=1;  // auf Badstrasse
             if (n3==3) k=11;  // Seestrasse
             if (n3==4) k=24;  // Opernplatz
             if (n3==5) k=39;  // Schlossallee
             if (n3==6) k=10;  // Gefaengnis
             if (n3==7) k=k-3;  // 3 Schritte zurueck
             if (n3==8) k=5; //Suedbahnhof
             if (n3==9) k=(k+9-((k+4)%10))%40; // na. Bhf.
           }
	 //Gemeinschaftskarte 
      if ((k==2)||(k==18)||(k==33))
           {
             if (n3==1) k=10; // Gefaengnis
             if (n3==2) k=0;  // Start
           }
         // Gefaengnis
         if (k==30) k=10; 
         x[k]=x[k]+1;
         if (k==10) r=0; 
    }
 }


int main()
{ const int N=40;
  long int x[N];
  long int c[N];
  int k,m;
  double y[N];
  cout<< "m  ?";
  cin >> m;
  for (k=0;k<40;k++)
    {
      x[k]=0;
    }
  monopoly(x,m);
  Farben(c);
  PlotBalken(x,40,c);
  for (k=0;k<40;k++)
    {
      y[k]=double(x[k])/double(m);
    }
  ausgabe(y,40);
  return 0;
}
